package flowarg.gunsofchickens.init;

import com.google.common.collect.Lists;
import flowarg.gunsofchickens.blocks.ChickenTNT;
import flowarg.gunsofchickens.blocks.GunsofchickensBlock;
import flowarg.gunsofchickens.utils.References;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.registry.GameRegistry;

import java.util.List;

public class ModBlocks {

    public static final ModBlocks INSTANCE = new ModBlocks();

    public static Block white_chicken_block;
    public static Block black_chicken_block;
    public static Block blue_chicken_block;
    public static Block red_chicken_block;
    public static Block yellow_chicken_block;
    public static Block multicolored_chicken_block;
    public static Block pink_chicken_block;
    public static Block orange_chicken_block;
    public static Block green_chicken_block;
    public static Block gray_chicken_block;
    public static Block brown_chicken_block;
    public static Block chicken_tnt;

    private List<Block> blocks;

    public void init()
    {

        blocks = Lists.newArrayList();

        black_chicken_block = new GunsofchickensBlock("black_chicken_block", Material.ROCK, 15.0f, 11.0f, 2, "pickaxe");
        white_chicken_block = new GunsofchickensBlock("white_chicken_block", Material.ROCK, 15.0f, 11.0f, 2, "pickaxe");
        blue_chicken_block = new GunsofchickensBlock("blue_chicken_block", Material.ROCK, 15.0f, 11.0f, 2, "pickaxe");
        red_chicken_block = new GunsofchickensBlock("red_chicken_block", Material.ROCK, 15.0f, 11.0f, 2, "pickaxe");
        yellow_chicken_block = new GunsofchickensBlock("yellow_chicken_block", Material.ROCK, 15.0f, 11.0f, 2, "pickaxe");
        multicolored_chicken_block = new GunsofchickensBlock("multicolored_chicken_block", Material.ROCK, 15.0f, 11.0f, 2, "pickaxe");
        pink_chicken_block = new GunsofchickensBlock("pink_chicken_block", Material.ROCK, 15.0f, 11.0f, 2, "pickaxe");
        orange_chicken_block = new GunsofchickensBlock("orange_chicken_block", Material.ROCK, 15.0f, 11.0f, 2, "pickaxe");
        green_chicken_block = new GunsofchickensBlock("green_chicken_block",Material.ROCK, 15.0f, 11.0f, 2, "pickaxe");
        gray_chicken_block = new GunsofchickensBlock("gray_chicken_block", Material.ROCK, 15.0f, 11.0f, 2, "pickaxe");
        brown_chicken_block = new GunsofchickensBlock("brown_chicken_block", Material.ROCK, 15.0f, 11.0f, 2, "pickaxe");
        chicken_tnt = new ChickenTNT("chicken_tnt");

        for (Block block : blocks) {
            ItemBlock ib = new ItemBlock(block);
            ib.setRegistryName(block.getRegistryName());
            GameRegistry.findRegistry(Item.class).register(ib);
        }

    }

    @SubscribeEvent
    public void registerModels(ModelRegistryEvent e)
    {
        for (Block b : blocks) {
            registerModel(b);
        }
    }

    private void registerModel(Block block)
    {

        ModelLoader.setCustomModelResourceLocation(Item.getItemFromBlock(block), 0, new ModelResourceLocation(new ResourceLocation(References.MODID, block.getUnlocalizedName().substring(5)), "inventory"));

    }

    public List<Block> getBlocks()
    {
        return blocks;
    }
}
