package flowarg.gunsofchickens.init;

import com.google.common.collect.Lists;
import flowarg.gunsofchickens.items.*;
import flowarg.gunsofchickens.utils.References;
import net.minecraft.client.renderer.block.model.ModelResourceLocation;
import net.minecraft.init.SoundEvents;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.*;
import net.minecraft.item.ItemArmor.ArmorMaterial;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.client.event.ModelRegistryEvent;
import net.minecraftforge.client.model.ModelLoader;
import net.minecraftforge.common.util.EnumHelper;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

import java.util.List;

import static flowarg.gunsofchickens.init.ModItems.ToolMaterials.chickenMat;

@Mod.EventBusSubscriber(modid = References.MODID)
public class ModItems
{
    public static final ModItems INSTANCE = new ModItems();

    public static Item chicken_launcher_black;
    public static Item chicken_with_tnt;
    public static Item chicken_launcher_blue;
    public static Item chicken_launcher_brown;
    public static Item chicken_launcher_gray;
    public static Item chicken_launcher_green;
    public static Item chicken_launcher_multicolored;
    public static Item chicken_launcher_orange;
    public static Item chicken_launcher_pink;
    public static Item chicken_launcher_red;
    public static Item chicken_launcher_white;
    public static Item chicken_launcher_yellow;
    public static Item chicken_ingot;
    public static ItemArmor chicken_helmet;
    public static ItemArmor chicken_chestplate;
    public static ItemArmor chicken_leggings;
    public static ItemArmor chicken_boots;
    public static Item chicken_sword;
    public static Item chicken_pickaxe;
    public static Item chicken_hoe;
    public static Item chicken_shovel;
    public static Item chicken_axe;

    private List<Item> items;

    public void init()
    {
        items = Lists.newArrayList();

        chicken_launcher_black = new ChickenLaunchers("chicken_launcher_black");
        chicken_with_tnt = new GunsofchickensItem("chicken_with_tnt");
        chicken_launcher_blue = new ChickenLaunchers("chicken_launcher_blue");
        chicken_launcher_brown = new ChickenLaunchers("chicken_launcher_brown");
        chicken_launcher_gray = new ChickenLaunchers("chicken_launcher_gray");
        chicken_launcher_green = new ChickenLaunchers("chicken_launcher_green");
        chicken_launcher_multicolored = new ChickenLaunchers("chicken_launcher_multicolored");
        chicken_launcher_orange = new ChickenLaunchers("chicken_launcher_orange");
        chicken_launcher_pink = new ChickenLaunchers("chicken_launcher_pink");
        chicken_launcher_red = new ChickenLaunchers("chicken_launcher_red");
        chicken_launcher_white = new ChickenLaunchers("chicken_launcher_white");
        chicken_launcher_yellow = new ChickenLaunchers("chicken_launcher_yellow");
        chicken_ingot = new GunsofchickensItem("chicken_ingot");
        chicken_helmet = new ChickenHelmet("chicken_helmet", ArmorMaterials.chickenMat, 2, EntityEquipmentSlot.HEAD);
        chicken_chestplate = new ChickenChestplate("chicken_chestplate", ArmorMaterials.chickenMat, 2, EntityEquipmentSlot.CHEST);
        chicken_leggings = new ChickenLeggings("chicken_leggings", ArmorMaterials.chickenMat, 2, EntityEquipmentSlot.LEGS);
        chicken_boots = new ChickenBoots("chicken_boots", ArmorMaterials.chickenMat, 2, EntityEquipmentSlot.FEET);
        chicken_sword = new ChickenSword("chicken_sword", chickenMat);
        chicken_pickaxe = new ChickenPickaxe("chicken_pickaxe", chickenMat);
        chicken_hoe = new ChickenHoe("chicken_hoe", chickenMat);
        chicken_shovel = new ChickenShovel("chicken_shovel", chickenMat);
        chicken_axe = new ChickenAxe("chicken_axe", chickenMat, 5f, 1.4f);
    }

    @SubscribeEvent
    public void registerModels(ModelRegistryEvent e)
    {
        for(Item item : items)
        {
            registerModel(item);
        }
    }
    private void registerModel(Item item)
    {
        ModelLoader.setCustomModelResourceLocation(item, 0, new ModelResourceLocation(new ResourceLocation(References.MODID, item.getUnlocalizedName().substring(5)), "inventory"));
    }

    public static class ArmorMaterials
    {
        public static final ArmorMaterial chickenMat = EnumHelper.addArmorMaterial("chickenMat", "gunsofchickens:chicken_armor", 500, new int[]{5, 7, 5, 3}, 6, SoundEvents.ITEM_ARMOR_EQUIP_DIAMOND, 0f);
    }

    public static class ToolMaterials
    {
        public static final Item.ToolMaterial chickenMat = EnumHelper.addToolMaterial("chickenMat", 3, 1600, 10f, 6f, 10);
    }

    public List<Item> getItems()
    {
        return items;
    }
}